package libViewer;

import java.awt.*;
import java.awt.image.*;

public class DrawArea extends Panel{

  ItemList  itemlist;
  TextArea StatusWindow;
  int shift_x = 0;
  int shift_y = 0;
  int SHIFT_Y = 0;
  int START_Y = 0;
  int LABEL_YOFFSET    = 0;
  int MIN_SPINE_HEIGHT = 0;
  int X_STARTVALUE     = 0;
  int ulc_y = 0;
  int ulc_x = 0;
  int MAX_CHARS = 40;

  String label = "";

  boolean oncreate = false;
  boolean new_row;

  // Settings
  int SPACE = 10;   // Space between Books

  public DrawArea(ItemList $itemlist, TextArea $StatusWindow) {
  itemlist  = $itemlist;
  StatusWindow = $StatusWindow;
  this.setLayout(null);      // very important if resizing the applet
  }
//------------------------------------------------------------------------------
public void paint (Graphics g) {

  if (Main.Zoomfactor.getSelectedItem() == "100%") {
      Main.zoom_factor = 1;
      X_STARTVALUE = 40;
      ulc_x = X_STARTVALUE;
      ulc_y = 70;
      SPACE = 10;
      LABEL_YOFFSET = 177;
      MIN_SPINE_HEIGHT = 140;
      }
  if (Main.Zoomfactor.getSelectedItem() == "33%") {
      Main.zoom_factor = 3;
      X_STARTVALUE = 25;
      ulc_x = X_STARTVALUE;
      ulc_y = 10;
      SPACE = 5;
      LABEL_YOFFSET = 86;
      MIN_SPINE_HEIGHT = 59;
      }

  ElementData elementdata = null;
  ElementData prev_elementdata = null;
  int spine_width  = 0;
  int spine_height = 0;

  // Regal zeichnen
  DrawShelve (Main.zoom_factor, g);    // sets also the SHIFT_Y Value

  // process all Items in ItemList

  Main.xpos = Main.down_xpos;
  new_row = true;

  while (Main.xpos < itemlist.number_items && ulc_y < Settings.DRAWAREA_HEIGHT) {

     prev_elementdata = elementdata;
     elementdata = itemlist.items[Main.xpos];
     spine_width  = (int) elementdata.spine_width / Main.zoom_factor;
     spine_height = (int) elementdata.spine_height / Main.zoom_factor;
     
     if (Settings.DRAWAREA_WIDTH - 30 <= ulc_x + spine_width) {
        g.setColor(Color.white);
        label = prev_elementdata.title;
        if (prev_elementdata.title.length() > MAX_CHARS) {
            label = prev_elementdata.title.substring(0,MAX_CHARS - 1);
            label = label + "...";
            }
        g.drawString("- " + label + " (" + (Main.xpos + Main.query_start -1) + ")", 380, ulc_y + LABEL_YOFFSET);
        new_row = true;
        ulc_y = ulc_y + SHIFT_Y;
        ulc_x = X_STARTVALUE;
        }
     /****** Draw Title on bookshelve if new row ******/
     if (new_row) {
     g.setColor(Color.white);
     label = elementdata.title;
     if (elementdata.title.length() > MAX_CHARS) {
            label = elementdata.title.substring(0,MAX_CHARS - 1);
            label = label + "...";
            }
     g.drawString(label + " (" + (Main.xpos + Main.query_start) + ")" + " -", 10, ulc_y + LABEL_YOFFSET);
     new_row = false; }
     /****** Calculate Shift-Values for dust_level ******/
     CalcShiftValues(elementdata);
     /****** Create Booktype and add Component ******/

     

     if (Main.not_on_repaint) {

     if (elementdata.datatype.compareTo("hardcover") == 0) {
             hardcover book = new hardcover(elementdata);
             this.add(book);
             book.createTitleArea();
             book.reshape(ulc_x + shift_x, ulc_y + shift_y - (spine_height - MIN_SPINE_HEIGHT),
                          spine_width,spine_height);
             }
     if (elementdata.datatype.compareTo("paperback") == 0) {
             paperback book = new paperback(elementdata);
             this.add(book);
             book.createTitleArea();
             book.reshape(ulc_x + shift_x, ulc_y + shift_y - (spine_height - MIN_SPINE_HEIGHT),
                          spine_width,spine_height);
             }
     if (elementdata.datatype.compareTo("newspaper") == 0) {
             newspaper book = new newspaper(elementdata);
             this.add(book);
             book.reshape(ulc_x + shift_x, ulc_y + shift_y - (spine_height - MIN_SPINE_HEIGHT),
                          spine_width,spine_height);
             }
     if (elementdata.datatype.compareTo("folder") == 0) {
             folder book = new folder(elementdata);
             this.add(book);
             book.createTitleArea();
             book.reshape(ulc_x + shift_x, ulc_y + shift_y - (spine_height - MIN_SPINE_HEIGHT),
                          spine_width,spine_height);
             }
     if (elementdata.datatype.compareTo("standard") == 0) {
             paperback book = new paperback(elementdata);
             this.add(book);
             book.createTitleArea();
             book.reshape(ulc_x + shift_x, ulc_y + shift_y - (spine_height - MIN_SPINE_HEIGHT),
                          spine_width,spine_height);
             }
     if ((elementdata.datatype.compareTo("video") == 0) ||
         (elementdata.datatype.compareTo("sublibrary") == 0) ||
         (elementdata.datatype.compareTo("software") == 0) ||
         (elementdata.datatype.compareTo("other") == 0) ||
         (elementdata.datatype.compareTo("html-doc") == 0) ||
         (elementdata.datatype.compareTo("audio") == 0)) {
             media book = new media(elementdata);
             this.add(book);
             book.createTitleArea();
             book.reshape(ulc_x + shift_x, ulc_y  + shift_y - (spine_height - MIN_SPINE_HEIGHT),
                          spine_width,spine_height);
             }
     }
     /****** Create side- and upper part of the Book ******/
     draw3DEffect  (elementdata, ulc_x + shift_x, ulc_y + shift_y);
     /****** Draw Convexity if Type = hardcover ******/
     if (elementdata.datatype.compareTo("hardcover") == 0) drawConvexity (elementdata, ulc_x + shift_x, ulc_y + shift_y);
     /****** Increase Drawing Position ******/
     ulc_x = ulc_x + spine_width + SPACE;


     if (Main.xpos == itemlist.number_items - 1)  {
         label = elementdata.title;
         if (elementdata.title.length() > MAX_CHARS) {
            label = elementdata.title.substring(0,MAX_CHARS - 1);
            label = label + "...";
            }
         g.drawString("- " + label + " (" + (Main.xpos + Main.query_start) + ")", 380, ulc_y + LABEL_YOFFSET);
         }
     Main.upper_xpos = Main.xpos;
     Main.xpos++;
  }
  Main.not_on_repaint = false;
  g.setColor(new Color(160,90,0));
  g.fillRect(Settings.DRAWAREA_WIDTH - 15,0,Settings.DRAWAREA_WIDTH - 15,Settings.DRAWAREA_HEIGHT);
}
//------------------------------------------------------------------------------
// Service Functions Section
//------------------------------------------------------------------------------
public void draw3DEffect (ElementData elementdata, int ulc_x, int ulc_y) {
  int XOFFSET = 0;
  int YOFFSET = 0;
  int FOLDER_XOFFSET1 = 0;
  int FOLDER_XOFFSET2 = 0;

  if (Main.zoom_factor == 1) {
      XOFFSET = 23; YOFFSET = 17; FOLDER_XOFFSET1 = 17; FOLDER_XOFFSET2 = 34; }

  if (Main.zoom_factor == 3) {
      XOFFSET = 10;  YOFFSET = 7; FOLDER_XOFFSET1 = 7; FOLDER_XOFFSET2 = 14; }

  int spine_width  = (int) elementdata.spine_width  / Main.zoom_factor;
  int spine_height = (int) elementdata.spine_height / Main.zoom_factor;

  int xpos = ulc_x;
  int ypos = ulc_y - (spine_height - MIN_SPINE_HEIGHT);

  // draw upper-side
  Graphics g = this.getGraphics();
  if (Settings.DRAW_SURFACE_COLOR2) g.setColor(elementdata.surface_color2);
  else g.setColor(elementdata.surface_color);

  Polygon pol = new Polygon();
  pol.addPoint(xpos , ypos);
  pol.addPoint(xpos + spine_width, ypos);
  if (elementdata.datatype.compareTo("folder")==0) pol.addPoint(xpos + spine_width + FOLDER_XOFFSET1, ypos - YOFFSET);
  else pol.addPoint(xpos + spine_width + XOFFSET, ypos - YOFFSET);
  if (elementdata.datatype.compareTo("folder")==0) pol.addPoint(xpos + FOLDER_XOFFSET2, ypos - YOFFSET);
  else pol.addPoint(xpos + XOFFSET, ypos - YOFFSET);
  g.fillPolygon(pol);

  // draw side
  g.setColor(elementdata.surface_color);

  Polygon pol1 = new Polygon();
  pol1.addPoint(xpos + spine_width, ypos + spine_height);
  if (elementdata.datatype.compareTo("folder")==0) pol1.addPoint(xpos + spine_width + FOLDER_XOFFSET1, ypos + spine_height - YOFFSET);
  else pol1.addPoint(xpos + spine_width + XOFFSET, ypos + spine_height - YOFFSET);
  if (elementdata.datatype.compareTo("folder")==0) pol1.addPoint(xpos + spine_width + FOLDER_XOFFSET1, ypos - YOFFSET);
  else pol1.addPoint(xpos + spine_width + XOFFSET, ypos - YOFFSET);
  pol1.addPoint(xpos + spine_width, ypos);
  g.fillPolygon(pol1);

  if (elementdata.datatype.compareTo("newspaper")==0) {
     int i;
     g.setColor(Color.darkGray);
     for (i = 0; i <= spine_width; i = i + 3) {
          g.drawLine(xpos + i, ypos, xpos + i + XOFFSET, ypos - YOFFSET);
          }
  }
}
//------------------------------------------------------------------------------
public void drawConvexity(ElementData elementdata, int ulc_x, int ulc_y) {

  int spine_width  = (int) elementdata.spine_width  / Main.zoom_factor;
  int spine_height = (int) elementdata.spine_height / Main.zoom_factor;
  int xpos = ulc_x;
  int ypos = ulc_y - (spine_height - MIN_SPINE_HEIGHT);
  Graphics g = this.getGraphics();
  g.setColor(elementdata.spine_color);
  g.fillOval(xpos+1,ypos+spine_height-5,spine_width - 2,(int)(spine_width / Settings.BULGE_FACTOR) + Settings.BULGE_HEIGHT);

}
//------------------------------------------------------------------------------
public void CalcShiftValues(ElementData elementdata) {
  if (Main.zoom_factor == 1) {
    // alte Einstellung 10 und 15
    shift_x = (- 14) + (int) (elementdata.zpos.floatValue() * Float.valueOf("14").floatValue());
    shift_y = 21 - (int) (elementdata.zpos.floatValue() * Float.valueOf("21").floatValue());
  }
  if (Main.zoom_factor == 3) {
    // alte Einstellung: 5 und 5
    shift_x = (- 8) + (int) (elementdata.zpos.floatValue() * Float.valueOf("8").floatValue());
    shift_y = 12 - (int) (elementdata.zpos.floatValue() * Float.valueOf("12").floatValue());
  }
}
//------------------------------------------------------------------------------
public void DrawShelve (int zoom_factor, Graphics g) {

  int THICKNESS = 45;
  int ANGLE_X = 0;

  int y;
  

  if (zoom_factor == 1) { SHIFT_Y = 250; START_Y = 235; THICKNESS = 45; ANGLE_X = 60;};
  if (zoom_factor == 3) { SHIFT_Y = 100; START_Y = 85; THICKNESS = 30;  ANGLE_X = 40;};

  /* linkes Seitenteil */
  g.setColor(new Color(130,70,0));
  g.fillRect(0,0,ANGLE_X,Settings.DRAWAREA_HEIGHT);

  for (y = START_Y; y < Settings.DRAWAREA_HEIGHT; y = y + SHIFT_Y) {

  g.setColor(new Color(120,60,0));
  Polygon pol = new Polygon();
  pol.addPoint(0,y);
  pol.addPoint(ANGLE_X, y - THICKNESS);
  pol.addPoint(Settings.DRAWAREA_WIDTH,y - THICKNESS);
  pol.addPoint(Settings.DRAWAREA_WIDTH,y);
  g.fillPolygon(pol);
  g.setColor(new Color(160,90,0));
  g.fillRect(0,y,Settings.DRAWAREA_WIDTH,15);

  }
}
//------------------------------------------------------------------------------
}