package libViewer;

import java.applet.*;
import java.awt.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;

public class Logos {

  // Array for Rows
  Row row[];
  int number_rows;
  boolean loaded = false;

  public Logos(TextArea StatusWindow) {

  int i;
  int x = -1;

  StatusWindow.appendText("Loading Logos Preferences File...\n");

  if (Settings.URL) {

  InputStream data1;
  DataInputStream data2;
  try {URL fileURL = new URL(Main.DocumentBase, Settings.LOGOS_FILENAME);

    try {data1 = fileURL.openStream();
         data2 = new DataInputStream(data1);

    // check out number of items in file and init Types-Array
    init_rows(countEntriesURL(Settings.LOGOS_FILENAME, StatusWindow));
    loaded = true;

    String line;                     // buffer for lines

    try {

    while ((line = data2.readLine()) != null) {             // until end of file - change to data2!!
    String parseit = "$";                                   // Character for Keywords
    String parm;                                            // buffer for arguments
    if (line.length() > 2) {                                // lines < 3 are useless (at least!)
      if (line.charAt(0) == parseit.charAt(0)) {            // Keyword is following
      line = line.substring(1);                             // cut Line - 1. character
      StringTokenizer st = new StringTokenizer(line);       // Separate Arguments
      if (st.countTokens() >= 2) {                          // at least 2 Tokens!

          parm = st.nextToken();                            // get Keyword
          int words = st.countTokens();

            if (parm.compareTo("LOGO_SHORTNAME") == 0) {          // parse Keywords sequentially
                x++;
                for (i = 0; i < words; i++) {
                row[x].Logo_Shortname = row[x].Logo_Shortname + st.nextToken();
                if (i != words - 1) row[x].Logo_Shortname = row[x].Logo_Shortname + " ";
                } }
            if (parm.compareTo("LOGO_FILENAME") == 0) {           // parse Keywords sequentially
                for (i = 0; i < words; i++) {
                row[x].Logo_Filename = row[x].Logo_Filename + st.nextToken();
                if (i != words - 1) row[x].Logo_Filename = row[x].Logo_Filename + " ";
                } }

      }
      else if (Settings.ERROR_DETAILS_ON) StatusWindow.appendText("WARNING: Invalid Line detected: $" + line + "\n");
      }

    }
    }// end while
    } catch (IOException io) {StatusWindow.appendText("ERROR: I/O Error!\n");  }
    } catch (IOException io) {StatusWindow.appendText("caught IO Exception.");}
    StatusWindow.appendText("Done!\n");
  } catch (IOException io) {StatusWindow.appendText("ERROR: File not found. File: " + Settings.LOGOS_FILENAME + "\n");}
    catch (SecurityException sec) {StatusWindow.appendText(sec.getMessage());}

  } // end if

  else {

  try {RandomAccessFile file = new RandomAccessFile(Settings.LOGOS_FILENAME, "r");

    // check out number of items in file and init Logo-Array
    init_rows(countEntriesFILE(Settings.LOGOS_FILENAME, StatusWindow));
    loaded = true;

    String line;                     // buffer for lines

    try {

    while ((line = file.readLine()) != null) {             // until end of file - change to data2!!

    String parseit = "$";                                   // Character for Keywords
    String parm;                                            // buffer for arguments
    if (line.length() > 2) {                                // lines < 3 are useless (at least!)
      if (line.charAt(0) == parseit.charAt(0)) {            // Keyword is following
      line = line.substring(1);                             // cut Line - 1. character
      StringTokenizer st = new StringTokenizer(line);       // Separate Arguments
      if (st.countTokens() >= 2) {                          // at least 2 Tokens!

          parm = st.nextToken();                            // get Keyword
          int words = st.countTokens();

            if (parm.compareTo("LOGO_SHORTNAME") == 0) {          // parse Keywords sequentially
                x++;
                for (i = 0; i < words; i++) {
                row[x].Logo_Shortname = row[x].Logo_Shortname + st.nextToken();
                if (i != words - 1) row[x].Logo_Shortname = row[x].Logo_Shortname + " ";
                } }
            if (parm.compareTo("LOGO_FILENAME") == 0) {           // parse Keywords sequentially
                for (i = 0; i < words; i++) {
                row[x].Logo_Filename = row[x].Logo_Filename + st.nextToken();
                if (i != words - 1) row[x].Logo_Filename = row[x].Logo_Filename + " ";
                } }

      }
      else if (Settings.ERROR_DETAILS_ON) StatusWindow.appendText("WARNING: Invalid Line detected: $" + line + "\n");
      }

    }
    }// end while
    } catch (IOException io) {StatusWindow.appendText("caught IO Exception.");}
    StatusWindow.appendText("Done!\n");
  } catch (IOException io) {StatusWindow.appendText("ERROR: File not found. File: " + Settings.LOGOS_FILENAME + "\n");}
    catch (SecurityException sec) {StatusWindow.appendText(sec.getMessage());}
  }
}
//------------------------------------------------------------------------------
  public static int countEntriesFILE (String Filename, TextArea StatusWindow) {
  int count = 0;
  String line;

  try { RandomAccessFile file = new RandomAccessFile(Filename, "r");

    try {

    while ((line = file.readLine()) != null) {             // until end of file - change to data2!!

    String parseit = "$";                                   // Character for Keywords
    String parm;
    if (line.length() > 2) {                                // lines < 3 are useless (at least!)
      if (line.charAt(0) == parseit.charAt(0)) {            // Keyword is following
      line = line.substring(1);                             // cut Line - 1. character
      StringTokenizer st = new StringTokenizer(line);       // Separate Arguments
      if (st.countTokens() >= 2) {                          // at least 2 Tokens!

          parm = st.nextToken();                            // get Keyword

          if (parm.compareTo("LOGO_SHORTNAME") == 0) {      // if we find the mandatory keyword "VEC_ID" we can increase the counter.
                count++;
                }
      }
     }
    }
    }// end while
    } catch (IOException io) {StatusWindow.appendText("I/O ERROR! File: " + Filename + "\n");}
    } catch (IOException io) {}
  return count;
  }
//------------------------------------------------------------------------------
  public static int countEntriesURL (String Filename, TextArea StatusWindow) {
  int count = 0;
  String line;
  InputStream data1;
  DataInputStream data2;
  try {URL fileURL = new URL(Main.DocumentBase, Filename);

    try {data1 = fileURL.openStream();
         data2 = new DataInputStream(data1);

    while ((line = data2.readLine()) != null) {             // until end of file - change to data2!!

    String parseit = "$";                                   // Character for Keywords
    String parm;
    if (line.length() > 2) {                                // lines < 3 are useless (at least!)
      if (line.charAt(0) == parseit.charAt(0)) {            // Keyword is following
      line = line.substring(1);                             // cut Line - 1. character
      StringTokenizer st = new StringTokenizer(line);       // Separate Arguments
      if (st.countTokens() >= 2) {                          // at least 2 Tokens!

          parm = st.nextToken();                            // get Keyword

          if (parm.compareTo("LOGO_SHORTNAME") == 0) {      // if we find the mandatory keyword "VEC_ID" we can increase the counter.
                count++;
                }
      }
     }
    }
    }// end while
    } catch (IOException io) {StatusWindow.appendText("caught IO Exception.");}
    } catch (IOException io) {StatusWindow.appendText("ERROR: File not found. File: " + Settings.LOGOS_FILENAME + "\n");}
    catch (SecurityException sec) {StatusWindow.appendText(sec.getMessage());}

  return count;
  }
//------------------------------------------------------------------------------
  public class Row {

    String  Logo_Shortname;
    String  Logo_Filename;
    Image   Logo;

    public Row () {

    Logo_Shortname = "";
    Logo_Filename  = "";

    }

  }

  public void init_rows (int number) {
    int i;
    this.number_rows = number;
    this.row = new Row[number];
    for (i = 0; i < number; i++) {
           this.row[i] = new Row();
    }

  }


}